/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-speech-recognition-msgs-1.0.40-0precise-20140920-0137/msg/SpeechRecognitionCandidates.msg
 *
 */


#ifndef SPEECH_RECOGNITION_MSGS_MESSAGE_SPEECHRECOGNITIONCANDIDATES_H
#define SPEECH_RECOGNITION_MSGS_MESSAGE_SPEECHRECOGNITIONCANDIDATES_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace speech_recognition_msgs
{
template <class ContainerAllocator>
struct SpeechRecognitionCandidates_
{
  typedef SpeechRecognitionCandidates_<ContainerAllocator> Type;

  SpeechRecognitionCandidates_()
    : transcript()
    , confidence()  {
    }
  SpeechRecognitionCandidates_(const ContainerAllocator& _alloc)
    : transcript(_alloc)
    , confidence(_alloc)  {
    }



   typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _transcript_type;
  _transcript_type transcript;

   typedef std::vector<float, typename ContainerAllocator::template rebind<float>::other >  _confidence_type;
  _confidence_type confidence;




  typedef boost::shared_ptr< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SpeechRecognitionCandidates_

typedef ::speech_recognition_msgs::SpeechRecognitionCandidates_<std::allocator<void> > SpeechRecognitionCandidates;

typedef boost::shared_ptr< ::speech_recognition_msgs::SpeechRecognitionCandidates > SpeechRecognitionCandidatesPtr;
typedef boost::shared_ptr< ::speech_recognition_msgs::SpeechRecognitionCandidates const> SpeechRecognitionCandidatesConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace speech_recognition_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'speech_recognition_msgs': ['/tmp/buildd/ros-groovy-speech-recognition-msgs-1.0.40-0precise-20140920-0137/msg'], 'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> >
{
  static const char* value()
  {
    return "8bf91ae2b1d4cbc38dce17013599f915";
  }

  static const char* value(const ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x8bf91ae2b1d4cbc3ULL;
  static const uint64_t static_value2 = 0x8dce17013599f915ULL;
};

template<class ContainerAllocator>
struct DataType< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> >
{
  static const char* value()
  {
    return "speech_recognition_msgs/SpeechRecognitionCandidates";
  }

  static const char* value(const ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string[] transcript   # candidate words of speech-to-text API\n\
float32[] confidence  # confidence of transcript\n\
";
  }

  static const char* value(const ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.transcript);
      stream.next(m.confidence);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SpeechRecognitionCandidates_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::speech_recognition_msgs::SpeechRecognitionCandidates_<ContainerAllocator>& v)
  {
    s << indent << "transcript[]" << std::endl;
    for (size_t i = 0; i < v.transcript.size(); ++i)
    {
      s << indent << "  transcript[" << i << "]: ";
      Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.transcript[i]);
    }
    s << indent << "confidence[]" << std::endl;
    for (size_t i = 0; i < v.confidence.size(); ++i)
    {
      s << indent << "  confidence[" << i << "]: ";
      Printer<float>::stream(s, indent + "  ", v.confidence[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // SPEECH_RECOGNITION_MSGS_MESSAGE_SPEECHRECOGNITIONCANDIDATES_H
